include:
- template: Jobs/Dependency-Scanning.latest.gitlab-ci.yml
- template: Jobs/License-Scanning.latest.gitlab-ci.yml
- template: Jobs/SAST.latest.gitlab-ci.yml
- template: Security/Coverage-Fuzzing.latest.gitlab-ci.yml

# Overriding 'Dependency-Scanning.gitlab-ci.yml' template, because
# we need to replace the rules with our own, the same
# as in `.merge_request_pipelines` template.
gemnasium-dependency_scanning:
  rules: !reference [".rules:merge_request_pipelines:no_docs", rules]

# Overriding 'License-Scanning.gitlab-ci.yml' template, because
# we need to replace the rules with our own, the same
# as in `.merge_request_pipelines` template.
license_scanning:
  variables:
    LICENSE_FINDER_CLI_OPTS: '--decisions-file=.gitlab/dependency_decisions.yml'
  rules: !reference [".rules:merge_request_pipelines:no_docs", rules]

check version definition:
  stage: test
  extends:
  - .rules:merge_request_pipelines
  needs: []
  script:
  - grep -E '^[0-9]+\.[0-9]+\.[0-9]+$' VERSION

# Perform documentation linting on Markdown files
docs lint markdown:
  image: registry.gitlab.com/gitlab-org/gitlab-docs/lint-markdown:alpine-3.18-vale-2.27.0-markdownlint-0.35.0-markdownlint2-0.8.1
  stage: test
  extends:
  - .rules:merge_request_pipelines
  - .no_cache_and_dependencies
  needs: []
  script:
  # Lint prose and Markdown
  - make lint-docs VALE_MIN_ALERT_LEVEL=error

# Perform link checks on published HTML files
docs check links:
  image: registry.gitlab.com/gitlab-org/gitlab-docs/lint-html:alpine-3.18-ruby-3.2.2-4207821e
  stage: test
  extends:
  - .rules:merge_request_pipelines
  - .no_cache_and_dependencies
  needs: []
  script:
  # Prepare docs for build
  - mv docs/ /tmp/gitlab-docs/content/$DOCS_GITLAB_REPO_SUFFIX
  - cd /tmp/gitlab-docs
  # Build HTML from Markdown
  - make compile
  # Check the internal links and anchors (in parallel)
  - "parallel time bundle exec nanoc check ::: internal_links internal_anchors"

check feature flags docs:
  stage: test
  extends:
  - .rules:merge_request_pipelines
  - .no_cache_and_dependencies
  script:
  - cp docs/configuration/feature-flags.md docs/configuration/feature-flags.md.orig
  - make update_feature_flags_docs
  - |
    diff docs/configuration/feature-flags.md.orig docs/configuration/feature-flags.md || (
      echo
      echo "Feature Flags list in documentation is not up-to-date"
      echo "Run 'make update_feature_flags_docs' to update it"
      echo
      exit 1
    )

check modules:
  stage: test
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .no_cache_and_dependencies
  needs:
  - 'prepare done'
  script:
  - make check_modules

check mocks:
  stage: test
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .no_cache_and_dependencies
  needs:
  - 'prepare done'
  script:
  - make check_mocks

check test directives:
  stage: test
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .no_cache_and_dependencies
  needs:
  - 'prepare done'
  script:
  - make check_test_directives

code_quality:
  stage: test
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .no_dependencies
  # Use GOCACHE instead of GOLANGCI_LINT_CACHE
  # to avoid [false lint positives](https://gitlab.com/gitlab-org/gitlab-runner/-/merge_requests/2187#note_373008672)
  - .go-cache
  image: registry.gitlab.com/gitlab-org/ci-cd/runner-tools/runner-linters:1.51.2-go1.19
  needs: []
  allow_failure: true
  variables:
    REPORT_FILE: gl-code-quality-report.json
    LINT_FLAGS: "--color never --deadline 15m"
    OUT_FORMAT: code-climate
    GOLANGLINT_VERSION: "" # Don't add version suffix to Makefile's GOLANGLINT (use plain golangci-lint from image)
  before_script:
  - source ci/touch_make_dependencies
  # Ensure the goargs linter plugin is available at .tmp/goargs.so to suit .golangci.yml
  - mkdir .tmp && ln -s /usr/lib/goargs.so .tmp/goargs.so
  # Copy the Docker image's golangci-lint to the location expected by `make lint` so that it is not built
  - cp $(which golangci-lint) .tmp/golangci-lint
  script:
  # Write the code coverage report to gl-code-quality-report.json
  # and print linting issues to stdout in the format: path/to/file:line description
  - make --silent lint | tee ${REPORT_FILE}
  timeout: 15 minutes
  artifacts:
    reports:
      codequality: ${REPORT_FILE}
    paths:
    - ${REPORT_FILE}
    when: always
    expire_in: 7d

.linux test:
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .docker
  - .go-cache
  stage: test
  before_script:
  - make splitic
  artifacts:
    paths:
    - .splitic/
    when: always
    expire_in: 7d
    reports:
      junit: .splitic/junit_*.xml

unit test:
  extends:
  - .linux test
  needs:
  - 'clone test repo'
  - 'prepare done'
  script:
  - >
    splitic test \
      -junit-report .splitic/junit_${CI_NODE_INDEX}.xml \
      -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner \
      -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_unix.env \
      ./... \
      -- -ldflags "$(make print_ldflags)"
  parallel: 2

unit test with race:
  extends:
  - unit test
  - .go-cache
  variables:
    CGO_ENABLED: "1"
  script:
  - make splitic
  - >
    splitic test \
      -race \
      -junit-report .splitic/junit_${CI_NODE_INDEX}.xml \
      -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner \
      -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_unix.env \
      ./... \
      -- -ldflags "$(make print_ldflags)"

integration test:
  extends:
  - .linux test
  needs:
  - 'clone test repo'
  - 'helper images'
  - 'prepare done'
  script:
  - >
    splitic test \
      -junit-report .splitic/junit_${CI_NODE_INDEX}.xml \
      -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner \
      -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_unix.env \
      -tags integration \
      ./... \
      -- -ldflags "$(make print_ldflags)" -timeout 15m
  parallel: 4

integration test with race:
  extends:
  - integration test
  - .go-cache
  variables:
    CGO_ENABLED: "1"
  script:
  - make splitic
  - >
    splitic test \
      -race \
      -junit-report .splitic/junit_${CI_NODE_INDEX}.xml \
      -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner \
      -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_unix.env \
      -tags integration \
      ./... \
      -- -ldflags "$(make print_ldflags)" -timeout 15m

fuzz variable mask:
  extends:
  - .fuzz_base
  - .rules:merge_request_pipelines:no_docs
  image: golang:$GO_VERSION
  stage: test
  variables:
    COVFUZZ_SEED_CORPUS: './helpers/trace/testdata/corpus'
  script:
  - apt update && apt install -y clang
  - go install github.com/dvyukov/go-fuzz/go-fuzz@latest && go install github.com/dvyukov/go-fuzz/go-fuzz-build@latest && go get github.com/dvyukov/go-fuzz/go-fuzz-dep@latest
  - go-fuzz-build -libfuzzer -o fuzz_variable_mask.a ./helpers/trace
  - clang -fsanitize=fuzzer fuzz_variable_mask.a -o fuzz_variable_mask
  - ./gitlab-cov-fuzz run -- ./fuzz_variable_mask -only_ascii=1 -max_len=128 -max_total_time=300

.go-cache-windows_before_script: &go-cache-windows_before_script
- New-Item -Path .gocache-$CI_COMMIT_REF_PROTECTED -Type Directory -Force

.windows test:
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .go-cache-windows
  stage: test
  parallel: 6
  before_script:
  - start-service docker
  - Set-MpPreference -DisableRealtimeMonitoring $true
  - git config --system core.longpaths true
  - New-ItemProperty -Path "HKLM:\SYSTEM\CurrentControlSet\Control\FileSystem" `
    -Name "LongPathsEnabled" -Value 1 -PropertyType DWORD -Force
  - go version
  - curl -o golang.msi "https://go.dev/dl/go$GO_VERSION.windows-amd64.msi"
  - Start-Process msiexec.exe -Wait -ArgumentList '/I golang.msi /quiet'
  - $env:Path = "C:\Program Files\Go\bin;$env:Path"
  - go version
  - *go-cache-windows_before_script
  - go install gitlab.com/ajwalker/splitic@latest
  - $env:Path += ";$(go env GOPATH)/bin"
  artifacts:
    paths:
    - .splitic/
    when: always
    expire_in: 7d
    reports:
      junit: .splitic/junit_*.xml
  allow_failure:
    exit_codes: 99

.windows unit test:
  extends:
  - .windows test
  parallel: 2
  needs:
  - 'clone test repo'
  - 'prepare done'
  script:
  - splitic test -junit-report .splitic/junit_${WINDOWS_VERSION}_${CI_NODE_INDEX}.xml -quarantined ci/.test-failures.${WINDOWS_VERSION}.txt -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_windows.env -fail-exit-code 99 ./...

.windows integration test:
  extends:
  - .windows test
  parallel: 4
  needs:
  - 'clone test repo'
  - 'prepare done'
  script:
  - splitic test -junit-report .splitic/junit_${WINDOWS_VERSION}_${CI_NODE_INDEX}.xml -quarantined ci/.test-failures.${WINDOWS_VERSION}.txt -cover-report .splitic/cover_${CI_NODE_INDEX}.profile -cover -coverpkg gitlab.com/gitlab-org/gitlab-runner -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_windows.env -fail-exit-code 99 -tags integration ./... -- -timeout 30m

# Only test the oldest supported version in merge requests,
# but test all versions in the default branch.
windows 1809 unit tests:
  extends:
  - .windows unit test
  - .windows1809
  - .rules:merge_request_pipelines:no_docs

windows 21H2 unit tests:
  extends:
  - .windows unit test
  - .windows21H2
  - .rules:merge_request_pipelines:no_docs:no-community-mr

windows 1809 integration tests:
  extends:
  - .windows integration test
  - .windows1809
  - .rules:merge_request_pipelines:no_docs:no-community-mr
  needs:
  - 'clone test repo'
  - 'prepare done'
  - job: 'development servercore1809 helper docker images'
    optional: true
  - job: 'bleeding edge servercore1809 helper docker images'
    optional: true
  - job: 'stable servercore1809 helper docker images'
    optional: true

windows 21H2 integration tests:
  extends:
  - .windows integration test
  - .windows21H2
  - .rules:merge_request_pipelines:no_docs:no-community-mr
  needs:
  - 'clone test repo'
  - 'prepare done'
  - job: 'development servercore21H2 helper docker images'
    optional: true
  - job: 'bleeding edge servercore21H2 helper docker images'
    optional: true
  - job: 'stable servercore21H2 helper docker images'
    optional: true

git 1.8.3.1:
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .go-cache
  image: centos:7
  stage: test
  variables:
    GOROOT: /usr/local/go
    GOPATH: /go
    CGO_ENABLED: 0
  before_script:
  - yum install -y -q git make patch && git version
  - curl https://storage.googleapis.com/golang/go$GO_VERSION.linux-amd64.tar.gz | tar zx -C $(dirname "$GOROOT")
  - curl -L https://github.com/git-lfs/git-lfs/releases/download/v${GIT_LFS_VERSION}/git-lfs-linux-amd64-v${GIT_LFS_VERSION}.tar.gz | tar zx
  - mv git-lfs-${GIT_LFS_VERSION}/git-lfs /usr/bin
  - git-lfs install --skip-repo
  - export PATH=${GOPATH}/bin:${GOROOT}/bin:$PATH
  - source ci/touch_make_dependencies
  script:
  - make git1.8-test

integration_k8s:
  extends:
  - .rules:merge_request_pipelines:no_docs
  - .docker
  needs:
  - 'prepare done'
  stage: test
  allow_failure: true # Will be fixed in !4228
  services:
  - name: registry.gitlab.com/gitlab-org/cluster-integration/test-utils/k3s-gitlab-ci/releases/v1.26.0-k3s1
    alias: k3s
    command:
      - server
      - --tls-san=k3s
      - --kube-apiserver-arg=feature-gates=ProcMountType=true
      - --disable-network-policy
  before_script:
  - curl k3s:8081?service=k3s > k3s.yaml
  - export KUBECONFIG=$(pwd)/k3s.yaml
  - kubectl version
  - kubectl cluster-info
  - make splitic
  script:
  - >
    splitic test \
      -tags integration,kubernetes \
      -env-passthrough ./scripts/envs/allowlist_common.env -env-passthrough ./scripts/envs/allowlist_unix.env \
      gitlab.com/gitlab-org/gitlab-runner/executors/kubernetes \
      -- -timeout=30m
